Subject: Re: OpenSSH crashes - able to repeat the cause
From: [email-masked] (Henry S. Thompson)
To: "Jack Radigan" <[email-masked]>
Cc: [email-masked]
Date: 25 Jan 2001 16:54:34 +0000

"Jack Radigan" <[email-masked]> writes:

> I'm doing the same at the moment.  When id.exe crashes go over to the
> system and do a 'ps' to find out the pid of id.exe.  Then, start gdb with:
> 
> 	gdb program <pid>
> 
> I'm able to see the registers but the stack is lost in space somewhere
> and doesn't show anything relevant.
> 
> Still playing, maybe you'll have better luck.

So I don't understand, I tried this yesterday and found that id was
running as root and I couldn't attach, but it isn't now -- maybe it
was sshd that was in that situation. . .

Anyway, I do now have a bit of stack information, not much use I
guess:

(gdb) info threads
  3 thread 26324.0x6770  0x77f9eeaa in _libkernel32_a_iname ()
* 2 thread 26324.0x66d8  0x77f820f0 in _libkernel32_a_iname ()
  1 thread 26324.0x66b0  0x77f820f0 in _libkernel32_a_iname ()

Attaching to program `/usr/bin/id.exe', process 26324
[Switching to thread 26324.0x6770]
(gdb) where
#0  0x77f9eeaa in _libkernel32_a_iname ()
#1  0x77ea8983 in _libkernel32_a_iname ()
#2  0x77e837cd in _libkernel32_a_iname ()

(gdb) info threads
* 3 thread 26324.0x6770  0x77f9eeaa in _libkernel32_a_iname ()
  2 thread 26324.0x66d8  0x77f820f0 in _libkernel32_a_iname ()
  1 thread 26324.0x66b0  0x77f820f0 in _libkernel32_a_iname ()

(gdb) thread 2
[Switching to thread 2 (thread 26324.0x66d8)]
#0  0x77f820f0 in _libkernel32_a_iname ()
(gdb) where
#0  0x77f820f0 in _libkernel32_a_iname ()
#1  0x77e8366e in _libkernel32_a_iname ()
#2  0x77e860c6 in _libkernel32_a_iname ()
#3  0x610041a2 in thread_stub (arg=0x61084554)
    at ../../../../winsup/cygwin/debug.cc:97
#4  0x77e837cd in _libkernel32_a_iname ()

(gdb) thread 1
[Switching to thread 1 (thread 26324.0x66b0)]
#0  0x77f820f0 in _libkernel32_a_iname ()
(gdb) where
#0  0x77f820f0 in _libkernel32_a_iname ()
#1  0x77e8366e in _libkernel32_a_iname ()
#2  0x77e860c6 in _libkernel32_a_iname ()
#3  0x610461b6 in _spawnve (hToken=0x0, mode=3, path=0xa014c58
"/usr/bin/id",
    argv=0xa014cd8, envp=0xa0147f8) at
../../../../winsup/cygwin/spawn.cc:882
#4  0x6100e169 in _execve (path=0xa014c58 "/usr/bin/id",
argv=0xa014cd8,
    envp=0xa0147f8) at ../../../../winsup/cygwin/exec.cc:34
#5  0x6106978a in execve (path=0xa014c58 "/usr/bin/id",
argv=0xa014cd8,
    envp=0xa0147f8) at ../../../../../newlib/libc/posix/execve.c:13
#6  0x411e54 in ?? ()
#7  0x411d80 in ?? ()
#8  0x4112f9 in ?? ()
#9  0x40e5ef in ?? ()
#10 0x444ccf in ?? ()
#11 0x420a12 in ?? ()
#12 0x423cbb in ?? ()
#13 0x41ee7c in ?? ()
#14 0x41eef4 in ?? ()
#15 0x41ef25 in ?? ()
#16 0x41ec91 in ?? ()
#17 0x41e76b in ?? ()
#18 0x41e93c in ?? ()
#19 0x424e84 in ?? ()
#20 0x424918 in ?? ()
#21 0x410cbc in ?? ()
#22 0x40e5ef in ?? ()
#23 0x444ccf in ?? ()
#24 0x44528e in ?? ()
#25 0x445330 in ?? ()
#26 0x401ff7 in _size_of_heap_reserve__ ()
#27 0x401796 in _size_of_heap_reserve__ ()
#28 0x61003825 in dll_crt0_1 () at
../../../../winsup/cygwin/dcrt0.cc:865
#29 0x61003a0d in _dll_crt0 () at
../../../../winsup/cygwin/dcrt0.cc:931
#30 0x61003a4c in dll_crt0 (uptr=0x0) at
../../../../winsup/cygwin/dcrt0.cc:943
#31 0x468d2d in ?? ()
#32 0x40103d in _size_of_heap_reserve__ ()
#33 0x77e992a6 in _libkernel32_a_iname ()

(gdb) up
#1  0x77e8366e in _libkernel32_a_iname ()
(gdb) up
#2  0x77e860c6 in _libkernel32_a_iname ()
(gdb) up
#3  0x610461b6 in _spawnve (hToken=0x0, mode=3, path=0xa014c58
"/usr/bin/id",
    argv=0xa014cd8, envp=0xa0147f8) at
../../../../winsup/cygwin/spawn.cc:882
882           spawn_guts (hToken, path, argv, envp, mode);
Current language:  auto; currently c++
(gdb) p argv
$1 = (char **) 0xa014cd8
(gdb) p *argv
$2 = 0xa014c18 "id"
(gdb) p argv[0]
$3 = 0xa014c18 "id"
(gdb) p argv[1]
$4 = 0xa014708 "-un"
(gdb) p argv[2]
$5 = 0x0

What more information should I now look for?

ht
-- 
  Henry S. Thompson, HCRC Language Technology Group, University of Edinburgh
          W3C Fellow 1999--2001, part-time member of W3C Team
     2 Buccleuch Place, Edinburgh EH8 9LW, SCOTLAND -- (44) 131 650-4440
	    Fax: (44) 131 650-4587, e-mail: [email-masked]
		     URL: http://www.ltg.ed.ac.uk/~ht/

--
Want to unsubscribe from this list?
Check out: http://cygwin.com/ml/#unsubscribe-simple